--- glui_filebrowser.cpp.orig	2007-11-08 01:36:23.000000000 -0700
+++ glui_filebrowser.cpp	2007-11-08 01:44:31.000000000 -0700
@@ -74,17 +74,16 @@
   if (!me)
     return;
   int this_item;
-  const char *selected;
   this_item = list->get_current_item();
   if (this_item > 0) { /* file or directory selected */
-    selected = list->get_item_ptr( this_item )->text.c_str();
-    if (selected[0] == '/' || selected[0] == '\\') {
+    const GLUI_String selected = list->get_item_ptr( this_item )->text.c_str();
+    if (*selected.rbegin() == '/' || selected[0] == '\\') {
       if (me->allow_change_dir) {
 #ifdef __GNUC__
-        chdir(selected+1);
+	chdir(selected.substr(0,selected.size()-1u).c_str());
 #endif
 #ifdef _WIN32
-        SetCurrentDirectory(selected+1);
+        SetCurrentDirectory(selected.substr(1).c_str());
 #endif
         me->fbreaddir(".");
       }
@@ -113,8 +112,8 @@
   
   hFind = FindFirstFile("*.*", &FN);
   if (list) {
-    list->delete_all();
     if (hFind != INVALID_HANDLE_VALUE) {
+      list->delete_all();
       do {
         int len = strlen(FN.cFileName);
         if (FN.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
@@ -141,10 +140,10 @@
   struct stat dr;
 
   if (list) {
-    list->delete_all();
     if ((dir = opendir(d)) == NULL)
       perror("fbreaddir:");
     else {
+      list->delete_all();
       while ((dirp = readdir(dir)) != NULL)   /* open directory     */
       { 
         if (!lstat(dirp->d_name,&dr) && S_ISDIR(dr.st_mode)) /* dir is directory   */
